#include <SPI.h>
#include <nRF24L01.h>
#include <RF24.h>
#include <Servo.h>

RF24 radio(9,10);
const uint64_t pipe = 0xF0F0F0F0E1LL;
Servo myservo;
int joystick[2];

long previousMillis = 0;
int key = 1;
int k=11;

void setup(void)
{
  // initialize the digital pin as an output.
  pinMode(5, OUTPUT);//фонари
  pinMode(6, OUTPUT);//сервомотор
  pinMode(7, OUTPUT);//двигатель
  pinMode(8, OUTPUT);//двигатель
  pinMode(14, OUTPUT);//динамик
  pinMode(15, OUTPUT);//динамик
  pinMode(16, OUTPUT);//B
  pinMode(17, OUTPUT);//G
  pinMode(18, OUTPUT);//R
  
  digitalWrite(14, HIGH);
  digitalWrite(15, LOW);
  
  joystick[1] |= 1<<3;
  
  radio.begin();
  radio.setRetries(15,15);
  radio.openReadingPipe(1,pipe);
  radio.startListening();
  
  myservo.attach(6);//сервомотор подключён к пину 6
  
}

void loop(void)
{
  if ( radio.available() )
  {
    bool done = false;
    while (!done)
    {
      done = radio.read( joystick, sizeof(joystick) );
      myservo.write(joystick[0]);
      //двигатель
      if ((joystick[1] & (1<<0))) 
      {
        digitalWrite(7, LOW);
      }
      else
      {
        digitalWrite(7, HIGH);
      }
      if ((joystick[1] & (1<<1))) 
      {
        digitalWrite(8, LOW);
      }
      else
      {
        digitalWrite(8, HIGH);
      }
      //фонари
      if ((joystick[1] & (1<<2))) 
      {
        digitalWrite(5, LOW);
      }
      else
      {
        digitalWrite(5, HIGH);
      }
    }
    //radio.read( joystick, sizeof(joystick) );
    //myservo.write(joystick[0]);
  }
  //мигалка, сирена
  if(!(joystick[1] & (1<<3)))
  {
     digitalWrite(17, LOW);//выключить зелёный
     if (micros() -previousMillis >k*100)   
     {
        previousMillis = micros();    
        //сирена
        digitalWrite(14,!digitalRead(14));
        digitalWrite(15,!digitalRead(15));
        //мигалка
        if(key==1)
        {
          digitalWrite(16, HIGH);
          digitalWrite(18, LOW);
          k++;
        }
        else 
        {
          digitalWrite(16, LOW);
          digitalWrite(18, HIGH);
          k--;
        }
  
        if(k>60)key=0;
        if(k<2)key=1;  
     }
  }
  else
  {
     digitalWrite(17, HIGH);//включить зелёный
  }
}
